package jam;

/**
 * <TT>JamObject</TT> is used to enforce any behavior which we want
 * all (or most of the) classes in Jag to have.  <BR>
 * We currently have <TT>copy()</TT> which is probably not generally
 * useful enough to have in JamObject.  It seems mostly useful for
 * <TT>jam.Vector</TT> and <TT>jam.Space</TT>.   <BR>
 * Also, the fact that we <TT>JamObject</TT> extends <TT>Cloneable</TT>
 * is probably a bad choice.  We initially thought that we could then
 * use <TT>clone()</TT> as a shallow copy for any <TT>JamObject</TT>.
 * The problem is that we intended the shallow copy to be <TT>public</TT>,
 * but <TT>clone()</TT> is actually <TT>protected</TT> in
 * <TT>java.lang.Object</TT>.  It was a stupid mistake.
 *
 */
public interface JamObject extends Cloneable {
  /** @return a (to some extent) deep copy of this */
  public JamObject copy();
}
