package jam.operator;

import  jam.vector.*;

/**
 * Binary operator
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @see       BiLinearOperator, SemiLinearOperator
 *
 * @author    Joel Schroeder
 */
public interface BinaryOperator extends jam.JamObject, Operator {
  public Space    getDomain1();
  public Space    getDomain2();

  public Vector      imageBinary(Vector d1, Vector d2          );
  public void        imageBinary(Vector d1, Vector d2, Vector r);
  public void     addImageBinary(Vector d1, Vector d2, Vector r);
  public void     residualBinary(Vector d1, Vector d2,
 			         Vector b ,            Vector r);

  /**
   * Returns the map d2 |---> A(d1,d2)
   * <BR>Alternate notation: A(d1,.) is the returned (unary) operator
   */
  public Operator getOp1(Vector d1);
  /**
   * Returns the linear map d1 |---> A(d1,d2)
   * <BR>Alternate notation: A(.,d2) is the returned (unary) operator
   */
  public Operator getOp2(Vector d2);
}
