package jam.operator;

import  jam.JamObject;
import java.util.Enumeration;

/**
 * A <TT>BlockOperator</TT> is an operator which can be written as a
 * matrix of operators.<BR>
 * So, usually it is a mapping between product vector spaces.
 * <BR><!--#include file="./source.inc"--><BR>
 * <BR>
 * Do we want to be able to multiply two BlockOperators to give a
 * BlockOperator of CompoundOperators?<BR>
 *
 * @author    Joel Schroeder
 */
public interface BlockOperator extends JamObject, Operator {
  /** If a sub-operator is not set, it is assumed to be zero */
  public void        setOp   (int i, int j, Operator op);
  /** If a sub-operator has not been set, the zero operator is returned */
  public Operator    getOp   (int i, int j);
  public int         size    ();
  public int         nRows   ();
  public int         nCols   ();
  public Enumeration elements();
}
