package jam.operator;

import  jam.vector.Vector;

/**
 * An <TT>OperatorVector</TT> is a mathematically a vector with the natural
 * operator behavior which follows from a vector.<BR>
 * Specifically, a vector may be thought of as a linear operator mapping
 * a real number to a vector via:<BR>
 * v(a) = a*v<BR>
 * In words, the operator v(.) maps the real number "a" to the vector which
 * is simply the vector "v" scaled by "a".<BR>
 * <BR>
 * The adjoint, then, is defined by:<BR>
 * v'(u) = dot(v,u)<BR>
 * In words, the adjoint of v, v'(.), maps the vector u to the real number
 * which is the inner product of v and u.<BR>
 * 
 * <BR><!--#include file="./source.inc"-->
 *
 * @author      Joel Schroeder
 */
public interface OperatorVector extends hasAdjoint {
  public Vector getVector();
}
