package jam.operator;

import  jam.JamObject;
import  jam.vector.*;

/**
 * Semilinear operator.<BR>
 * An operator, A is a semilinear operator if A(x1,x2) is a binary operator,
 * <BR>
 * such that A(x1,*) (as an operator on an x2-type vector) is linear,<BR>
 * and A(*,x2) (as an operator on an x1-type vector) is non-linear.
 *
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Joel Schroeder
 */
public interface SemiLinearOperator extends JamObject, BinaryOperator {
  /**
   * Returns the     linear map d2 |---> A(d1,d2)
   * <BR>Alternate notation: A(d1,.) is a     linear operator
   */
  public LinearOperator getLinearOp   (Vector d2);
  /**
   * Returns the non-linear map d1 |---> A(d1,d2)
   * <BR>Alternate notation: A(.,d2) is a non-linear operator
   */
  public Operator       getNonLinearOp(Vector d1);
}
