package jam.operator;

import  jam.JamObject;
import  jam.vector.*;

/**
 * <TT>hasAdjoint</TT> is a <TT>LinearOperator</TT> in which both the adjoint
 * and forward are implemented.<BR>
 * <BR>
 * For a linear operator, the gradient is simply the adjoint (since we define
 * the gradient as the adjoint of the derivative, and for a linear operator,
 * the derivative is simply the operator itself).  Therefore, since we have
 * the adjoint implemented, we can extend <TT>hasGradient</TT> virtually for
 * free.<BR>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Joel Schroeder
 */
public interface hasAdjoint extends JamObject, LinearOperator, hasDerivative {
  /**
   * @return the adjoint of this
   */
  public hasAdjoint adjoint();
}
