package jam.operator;

import  jam.vector.Vector;

/**
 * A <TT>hasDerivative</TT> is an operator in which the gradient and
 * derivative are implemented.  We demand that the derivative be a
 * <TT>hasAdjoint</TT> whose adjoint is equal to the gradient.<BR>
 * (For linear operators, the derivative is just the operator itself.)
 * <BR>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Joel Schroeder
 */
public interface hasDerivative extends jam.JamObject, hasGradient {
  /**
   * getDerivativeAt(x) returns the adjoint of getGradientAt(x)
   */
  public hasAdjoint getDerivativeAt(Vector x);
}
