package jam.solver;

/**
 * A <TT>Finisher</TT> has a finish() method that is executed by a solver
 * after looping. 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Matt Schwab
 * @version     15 Mar 1997
 */
public interface Finisher { 
  /** 
   * The solver reference enables us to access its methods
   */
  public void setSolver(IterativeSolver slv);
  /**
   * A solver executes it while looping. finished() returns true when 
   * the convergence criteria is fulfilled. Otherwise it returns false. 
   */
  public void finish();
}
