package jam.solver;

import  jam.vector.*;

/**
 * Iterative Solver solves a problem A x - b = 0 for x.
 * <BR><!--#include file="./source.inc"-->
 *
 * Maybe we should have something like getGradient();                 <BR>
 * Maybe we should have something like getOperator() and getVector(); <BR>
 * 
 * Some of these can be implemented in a very general fashion. 
 * 
 * @author      Matt Schwab
 * @version     15 Mar 1997
 */
public interface IterativeSolver extends Solver {
  /**
   * @return Vector current x (converges to the solution while iterating)
   */
  public     Vector getApproximation();
  /**
   * @return Vector current A x - b 
   */
  public     Vector getResidual();
  /**
   * @return float  current |A x - b| ^2
   */
  public     float  getNormResidual();
  /**
   * @return float  current (|A x - b| / |A x_0 - b|) ^2
   */
  public     float  getRelativeNormResidual();
  /**
   * @return int    number of iterations
   */
  public     int    getIteration();
}
