package jam.solver;

/**
 * A <TT>Reporter</TT> has a report() method that is executed by a solver
 * while looping. nextIteration() is usually used to report on the current 
 * approximation of the solution. It can also be used to save intermediate
 * approximations for possible restarts. 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Matt Schwab
 * @version     15 Mar 1997
 */
public interface Reporter { 
  /** 
   * The solver reference enables us to access its methods
   */
  public void setSolver(IterativeSolver slv);
  /**
   * A solver executes it while looping. 
   */
  public void nextIteration();
}
