package jam.solver;

/**
 * A <TT>Terminator</TT> has a hasMoreIterations() method that 
 * is executed by a solver before starting a new iteration step. 
 * if hasMoreIterations(0 returns false the solver stops iterating.
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Matt Schwab
 * @version     15 Mar 1997
 */
public interface Terminator { 
  /** 
   * The solver reference enables us to access its methods
   */
  public void setSolver(IterativeSolver slv);
  /**
   * A solver executes it after looping
   */
  public boolean hasMoreIterations();
}
