package jam.vector;

/**
 * A <TT>Basis</TT> is a set of (not necessarily orthonormal) vectors
 * which span a given <TT>Space</TT><BR>
 *
 * <BR><!--#include file="./source.inc"-->
 *
 * @author      Joel Schroeder
 */
public interface Basis extends jam.JamObject {
  /** @return the vector space to which the vectors in the basis belong */
  public SpaceBasis getSpace();
  /** @return the number of vectors in the basis */
  public int        size();
  /** @return basis vector number i, where i runs from 0 to size() - 1 */
  public Vector     getVector(int i);
}
