package jam.vector;

import  jam.JamObject;
import java.util.Enumeration;

/**
 * <TT>ProductSpace</TT> is a vector space for a <TT>ProductVector</TT>.<BR>
 *
 * <BR><!--#include file="./source.inc"-->
 * 
 * @see         ProductVector
 * @author      Joel Schroeder
 */
public interface ProductSpace extends JamObject, Space {
  /**
   * @return number of vector spaces which compose the product space
   */
  public int   	      size();
  public Space 	      getSubSpace(int i);
  public void         setSubSpace(int i, Space spc);
  /** Do we want to remove addLast() and addFirst()? */
  public void  	      addLast (Space last );
  /** Do we want to remove addLast() and addFirst()? */
  public void  	      addFirst(Space first);
  public Enumeration  elements();
}
