package jam.vector;

import  jam.JamObject;
import java.util.Enumeration;

/**
 * A <TT>ProductVector</TT> is a vector composed of sub-vectors.<BR>
 * For example, two column vectors can be stacked to give a larger
 * "product column vector".<BR>
 *
 * <BR><!--#include file="./source.inc"-->
 * 
 * @see         ProductSpace
 * @author      Joel Schroeder
 */
public interface ProductVector extends JamObject, Vector {
  /**
   * @return number of vector spaces which compose the product space
   */
  public int          size();
  public Vector       getSubVector(int i);
  public void         setSubVector(int i, Vector vec);
  public Enumeration  elements();
}
